# Xperimental [static glfw] linux compile script
#
# uses rpath to tell runtime linker to look also in
# ./libs/gnu/ for any needed *.so files not found elsewhere



# set path to AdaCore gnat compiler...
# or delete next line if gnat is visible:
#export PATH=$HOME/opt/GNAT/2021/bin:$PATH
export PATH=$HOME/opt/GNAT/2016/bin:$PATH







gnatmake asudx -o lsudx \
-O3 -gnat12 \
-D ./obj \
-I../src \
-I../src/adautils \
-I../src/adabindings/gl \
-I../src/adabindings/glfwada \
-I../src/adabindings/AdaPngLib \
-largs \
-lGL  -lX11 -lpthread \
-lstdc++ -lz -lm \
-Wl,-rpath,'$ORIGIN/libs/gnu' \
-L$PWD/../libs/gnu \
-lglfw

mv lsudx ..





# -- Copyright (C) 2022  <fastrgv@gmail.com>
# --
# -- This program is free software: you can redistribute it and/or modify
# -- it under the terms of the GNU General Public License as published by
# -- the Free Software Foundation, either version 3 of the License, or
# -- (at your option) any later version.
# --
# -- This program is distributed in the hope that it will be useful,
# -- but WITHOUT ANY WARRANTY; without even the implied warranty of
# -- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# -- GNU General Public License for more details.
# --
# -- You may read the full text of the GNU General Public License
# -- at <http://www.gnu.org/licenses/>.

